1 #!/bin/sh -- # no runable script, just for vi
5 # we all like colorful messages
6 if [ "$MSGCOLOR" != 'NO' ] && [ "$MSGCOLOR" != 'ALWAYS' ]; then
7 if [ ! -t 1 ]; then # but check that we output to a terminal
13 if [ "$MSGCOLOR" != 'NO' ]; then
14 CERROR
="\033[1;31m" # red
15 CWARNING
="\033[1;33m" # yellow
16 CMSG
="\033[1;32m" # green
17 CINFO
="\033[1;96m" # light blue
18 CDEBUG
="\033[1;94m" # blue
19 CNORMAL
="\033[0;39m" # default system console color
20 CDONE
="\033[1;32m" # green
21 CPASS
="\033[1;32m" # green
22 CFAIL
="\033[1;31m" # red
23 CCMD
="\033[1;35m" # pink
35 printf "$MIDDLE " "$(echo "$1" | sed -e 's#^apt\([cfghs]\)#apt-\1#')"
41 msgdie
() { msgprintf
"${CERROR}E: %s" '%s' "${CNORMAL}\n" "$@" >&2; exit 1; }
42 msgwarn
() { msgprintf
"${CWARNING}W: %s" '%s' "${CNORMAL}\n" "$@" >&2; }
43 msgmsg
() { msgprintf
"${CMSG}%s" '%s' "${CNORMAL}\n" "$@"; }
44 msginfo
() { msgprintf
"${CINFO}I: %s" '%s' "${CNORMAL}\n" "$@"; }
45 msgdebug
() { msgprintf
"${CDEBUG}D: %s" '%s' "${CNORMAL}\n" "$@"; }
46 msgdone
() { msgprintf
"${CDONE}DONE" '%s' "${CNORMAL}\n" "$@"; }
47 msgnwarn
() { msgprintf
"${CWARNING}W: %s" '%s' "${CNORMAL}" "$@" >&2; }
48 msgnmsg
() { msgprintf
"${CMSG}%s" '%s' "${CNORMAL}" "$@"; }
49 msgninfo
() { msgprintf
"${CINFO}I: %s" '%s' "${CNORMAL}" "$@"; }
50 msgndebug
() { msgprintf
"${CDEBUG}D: %s" '%s' "${CNORMAL}" "$@"; }
51 msgtest
() { msgprintf
"${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@"; }
52 msgpass
() { printf "${CPASS}PASS${CNORMAL}\n"; }
54 if [ $# -gt 0 ]; then printf "${CWARNING}SKIP: $*${CNORMAL}\n" >&2;
55 else printf "${CWARNING}SKIP${CNORMAL}\n" >&2; fi
58 if [ $# -gt 0 ]; then printf "${CFAIL}FAIL: $*${CNORMAL}\n" >&2;
59 else printf "${CFAIL}FAIL${CNORMAL}\n" >&2; fi
60 if [ -n "$APT_DEBUG_TESTS" ]; then
63 EXIT_CODE
=$((EXIT_CODE+1));
66 # enable / disable Debugging
67 MSGLEVEL
=${MSGLEVEL:-3}
68 if [ $MSGLEVEL -le 0 ]; then
71 if [ $MSGLEVEL -le 1 ]; then
75 if [ $MSGLEVEL -le 2 ]; then
79 msgpass
() { printf " ${CPASS}P${CNORMAL}"; }
81 if [ $MSGLEVEL -le 3 ]; then
85 if [ $MSGLEVEL -le 4 ]; then
90 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
91 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
92 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
93 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
94 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
97 printf "${CDONE}DONE${CNORMAL}\n";
101 if [ -f .
/aptconfig.conf
]; then
102 echo "./aptconfig.conf"
103 elif [ -f ..
/aptconfig.conf
]; then
104 echo "../aptconfig.conf"
108 msgdebug
"Executing: ${CCMD}$*${CDEBUG} "
112 sh
|aptitude
|*/*|command) ;;
113 *) CMD
="${BUILDDIRECTORY}/$CMD";;
115 MALLOC_PERTURB_
=21 MALLOC_CHECK_
=2 APT_CONFIG
="$(getaptconfig)" LD_LIBRARY_PATH
=${LIBRARYPATH} $CMD "$@"
117 aptconfig
() { runapt apt
-config "$@"; }
118 aptcache
() { runapt apt
-cache "$@"; }
119 aptcdrom
() { runapt apt
-cdrom "$@"; }
120 aptget
() { runapt apt
-get "$@"; }
121 aptftparchive
() { runapt apt
-ftparchive "$@"; }
122 aptkey
() { runapt apt
-key "$@"; }
123 aptmark
() { runapt apt
-mark "$@"; }
124 aptsortpkgs
() { runapt apt
-sortpkgs "$@"; }
125 apt
() { runapt apt
"$@"; }
126 apthelper
() { runapt
"${APTHELPERBINDIR}/apt-helper" "$@"; }
127 aptwebserver
() { runapt
"${APTWEBSERVERBINDIR}/aptwebserver" "$@"; }
128 aptitude
() { runapt aptitude
"$@"; }
129 aptextracttemplates
() { runapt apt
-extracttemplates "$@"; }
130 aptinternalsolver
() { runapt
"${APTINTERNALSOLVER}" "$@"; }
131 aptdumpsolver
() { runapt
"${APTDUMPSOLVER}" "$@"; }
134 "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "$@"
136 dpkgcheckbuilddeps
() {
137 command dpkg
-checkbuilddeps --admindir=${TMPWORKINGDIRECTORY}/rootdir
/var
/lib
/dpkg
"$@"
142 aptget
) CMD
="apt-get";;
143 aptcache
) CMD
="apt-cache";;
144 aptmark
) CMD
="apt-mark";;
145 apthelper
) CMD
="apt-helper";;
149 runapt
command gdb
--quiet -ex run
"${BUILDDIRECTORY}/$CMD" --args "${BUILDDIRECTORY}/$CMD" "$@"
153 # error if we about to overflow, but ...
154 # "255 failures ought to be enough for everybody"
155 if [ $EXIT_CODE -gt 255 ]; then
156 msgdie
"Total failure count $EXIT_CODE too big"
158 exit $((EXIT_CODE <= 255 ? EXIT_CODE : 255));
161 shellsetedetector
() {
163 if [ "$exit_status" != '0' ]; then
164 printf >&2 "${CERROR}E: Looks like the testcases ended prematurely with exitcode: ${exit_status}${CNORMAL}\n"
165 if [ "$EXIT_CODE" = '0' ]; then
166 EXIT_CODE
="$exit_status"
172 if [ "$1" = 'prefix' ]; then
173 CURRENTTRAP
="$2 $CURRENTTRAP"
175 CURRENTTRAP
="$CURRENTTRAP $1"
177 trap "shellsetedetector; $CURRENTTRAP exitwithstatus;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
181 # privilege dropping and testing doesn't work if /tmp isn't world-writeable (as e.g. with libpam-tmpdir)
182 if [ -n "$TMPDIR" ] && [ "$(id -u)" = '0' ] && [ "$(stat --format '%a' "$TMPDIR")" != '1777' ]; then
185 TMPWORKINGDIRECTORY
=$(mktemp -d)
186 addtrap
"cd /; rm -rf $TMPWORKINGDIRECTORY;"
187 msgninfo
"Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
189 mkdir -m 700 "${TMPWORKINGDIRECTORY}/downloaded"
190 if [ "$(id -u)" = '0' ]; then
191 # relax permissions so that running as root with user switching works
193 chmod 711 "$TMPWORKINGDIRECTORY"
194 chown _apt
:root
"${TMPWORKINGDIRECTORY}/downloaded"
197 TESTDIRECTORY
=$(readlink -f $(dirname $0))
198 # allow overriding the default BUILDDIR location
199 SOURCEDIRECTORY
=${APT_INTEGRATION_TESTS_SOURCE_DIR:-"${TESTDIRECTORY}/../../"}
200 BUILDDIRECTORY
=${APT_INTEGRATION_TESTS_BUILD_DIR:-"${TESTDIRECTORY}/../../build/bin"}
201 LIBRARYPATH
=${APT_INTEGRATION_TESTS_LIBRARY_PATH:-"${BUILDDIRECTORY}"}
202 METHODSDIR
=${APT_INTEGRATION_TESTS_METHODS_DIR:-"${BUILDDIRECTORY}/methods"}
203 APTHELPERBINDIR
=${APT_INTEGRATION_TESTS_LIBEXEC_DIR:-"${BUILDDIRECTORY}"}
204 APTWEBSERVERBINDIR
=${APT_INTEGRATION_TESTS_WEBSERVER_BIN_DIR:-"${BUILDDIRECTORY}"}
205 APTINTERNALSOLVER
=${APT_INTEGRATION_TESTS_INTERNAL_SOLVER:-"${BUILDDIRECTORY}/apt-internal-solver"}
206 APTDUMPSOLVER
=${APT_INTEGRATION_TESTS_DUMP_SOLVER:-"${BUILDDIRECTORY}/apt-dump-solver"}
207 test -x "${BUILDDIRECTORY}/apt-get" || msgdie
"You need to build tree first"
210 cd $TMPWORKINGDIRECTORY
211 mkdir rootdir aptarchive keys
213 mkdir -p etc
/apt
/apt.conf.d etc
/apt
/sources.list.d etc
/apt
/trusted.gpg.d etc
/apt
/preferences.d
214 mkdir -p usr
/bin var
/cache var
/lib var
/log tmp
215 mkdir -p var
/lib
/dpkg
/info var
/lib
/dpkg
/updates var
/lib
/dpkg
/triggers
216 touch var
/lib
/dpkg
/available
218 ln -s ${METHODSDIR} usr
/lib
/apt
/methods
219 if [ "$BUILDDIRECTORY" = "$LIBRARYPATH" ]; then
220 mkdir -p usr
/lib
/apt
/solvers
221 ln -s "${BUILDDIRECTORY}/apt-dump-solver" usr
/lib
/apt
/solvers
/dump
222 ln -s "${BUILDDIRECTORY}/apt-internal-solver" usr
/lib
/apt
/solvers
/apt
223 echo "Dir::Bin::Solvers \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/solvers\";" > etc
/apt
/apt.conf.d
/externalsolver.conf
225 # use the autoremove from the BUILDDIRECTORY if its there, otherwise
227 if [ -e ${BUILDDIRECTORY}/..
/..
/debian
/apt.conf.autoremove
]; then
228 ln -s ${BUILDDIRECTORY}/..
/..
/debian
/apt.conf.autoremove etc
/apt
/apt.conf.d
/01autoremove
230 ln -s /etc
/apt
/apt.conf.d
/01autoremove etc
/apt
/apt.conf.d
/01autoremove
233 local PACKAGESFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
234 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
235 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
237 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
238 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
239 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive
/Sources
241 cp $(find $TESTDIRECTORY -name '*.pub' -o -name '*.sec') keys
/
242 chmod 644 $(find keys -name '*.pub' -o -name '*.sec')
243 ln -s ${TMPWORKINGDIRECTORY}/keys
/joesixpack.pub rootdir
/etc
/apt
/trusted.gpg.d
/joesixpack.gpg
245 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
246 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
247 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
248 echo "Dir::Bin::Methods \"${METHODSDIR}\";" >> aptconfig.conf
249 # store apt-key were we can access it, even if we run it as a different user
250 # destroys coverage reporting though, so just do it for root for now
251 if [ "$(id -u)" = '0' ]; then
252 cp "${BUILDDIRECTORY}/apt-key" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/"
253 chmod o
+rx
"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key"
254 echo "Dir::Bin::apt-key \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key\";" >> aptconfig.conf
256 echo "Dir::Bin::apt-key \"${BUILDDIRECTORY}/apt-key\";" >> aptconfig.conf
259 cat << EOF > "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg"
262 if [ -r "${TMPWORKINGDIRECTORY}/noopchroot.so" ]; then
263 if [ -n "\$LD_PRELOAD" ]; then
264 export LD_PRELOAD="${TMPWORKINGDIRECTORY}/noopchroot.so \${LD_PRELOAD}"
266 export LD_PRELOAD="${TMPWORKINGDIRECTORY}/noopchroot.so"
269 exec fakeroot dpkg --root="${TMPWORKINGDIRECTORY}/rootdir" \\
270 --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log \\
271 --force-not-root --force-bad-path "\$@"
273 chmod +x
"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg"
274 echo "Dir::Bin::dpkg \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg\";" > rootdir
/etc
/apt
/apt.conf.d
/99dpkg
276 if ! command dpkg
--assert-multi-arch >/dev
/null
2>&1; then
277 echo "DPKG::options:: \"--force-architecture\";" >> aptconfig.conf
# Added to test multiarch before dpkg is ready for it…
279 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
280 echo 'quiet::NoStatistic "true";' >> aptconfig.conf
281 # too distracting for users, but helpful to detect changes
282 echo 'Acquire::Progress::Ignore::ShowErrorText "true";' >> aptconfig.conf
283 # in testcases, it can appear as if localhost has a rotation setup,
284 # hide this as we can't really deal with it properly
285 echo 'Acquire::Failure::ShowIP "false";' >> aptconfig.conf
287 cp "${TESTDIRECTORY}/apt.pem" "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem"
288 if [ "$(id -u)" = '0' ]; then
289 chown _apt
:root
"${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem"
291 echo "Acquire::https::CaInfo \"${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem\";" > rootdir
/etc
/apt
/apt.conf.d
/99https
292 echo "Apt::Cmd::Disable-Script-Warning \"1\";" > rootdir
/etc
/apt
/apt.conf.d
/apt
-binary
293 configcompression
'.' 'gz' #'bz2' 'lzma' 'xz'
295 # create some files in /tmp and look at user/group to get what this means
296 TEST_DEFAULT_USER
="$USER"
297 if [ "$(uname)" = 'GNU/kFreeBSD' ]; then
298 TEST_DEFAULT_GROUP
='root'
300 TEST_DEFAULT_GROUP
="$USER"
303 # Acquire::AllowInsecureRepositories=false is not yet the default
304 # but we want it to be the default soon
305 configallowinsecurerepositories
"false";
307 # cleanup the environment a bit
308 # prefer our apt binaries over the system apt binaries
309 export PATH
="${BUILDDIRECTORY}:${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
310 export LC_ALL
=C.UTF
-8
311 unset LANGUAGE APT_CONFIG
312 unset GREP_OPTIONS DEB_BUILD_PROFILES
318 if [ "$1" = "native" -o -z "$1" ]; then
319 eval `aptconfig shell ARCH APT::Architecture`
320 if [ -n "$ARCH" ]; then
323 dpkg
--print-architecture
331 aptconfig dump
--no-empty --format '%v%n' APT
::Architecture APT
::Architectures
| sort -u | tr '\n' ' '
334 getarchitecturesfromcommalist
() {
335 echo "$1" | sed -e 's#,#\n#g' | sed -e "s/^native\$/$(getarchitecture 'native')/"
338 configarchitecture
() {
340 echo "APT::Architecture \"$(getarchitecture $1)\";"
341 while [ -n "$1" ]; do
342 echo "APT::Architectures:: \"$(getarchitecture $1)\";"
345 } >rootdir
/etc
/apt
/apt.conf.d
/01multiarch.conf
350 if [ ! -e rootdir
/var
/lib
/dpkg
/status
]; then
351 local STATUSFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
352 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
353 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
355 echo -n > rootdir/var/lib/dpkg/status
358 rm -f rootdir/etc/apt/apt.conf.d/00foreigndpkg
359 if command dpkg --assert-multi-arch >/dev/null 2>&1 ; then
360 local ARCHS="$(getarchitectures)"
361 if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
362 DPKGARCH="$(dpkg --print-architecture)"
363 for ARCH in ${ARCHS}; do
364 if [ "${ARCH}" != "${DPKGARCH}" ]; then
365 if ! dpkg --add-architecture ${ARCH} >/dev/null 2>&1; then
366 # old-style used e.g. in Ubuntu-P – and as it seems travis
367 echo "DPKG
::options
:: \"--foreign-architecture\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
368 echo "DPKG
::options
:: \"${ARCH}\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
372 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
373 # dpkg doesn't really check the version as long as it is fully installed,
374 # but just to be sure we choose one above the required version
375 insertinstalledpackage 'dpkg' "all
" '1.16.2+fake'
381 configdpkgnoopchroot() {
382 # create a library to noop chroot() and rewrite maintainer script executions
383 # via execvp() as used by dpkg as we don't want our rootdir to be a fullblown
384 # chroot directory dpkg could chroot into to execute the maintainer scripts
385 msgtest 'Building library to preload to make maintainerscript work in' 'dpkg'
386 cat << EOF > noopchroot.c
393 static char * chrootdir = NULL;
395 int chroot(const char *path) {
396 printf("WARNING
: CHROOTing to
%s was ignored
!\n", path);
398 chrootdir = strdup(path);
401 int execvp(const char *file, char *const argv[]) {
402 static int (*func_execvp) (const char *, char * const []) = NULL;
403 if (func_execvp == NULL)
404 func_execvp = (int (*) (const char *, char * const [])) dlsym(RTLD_NEXT, "execvp
");
405 if (chrootdir == NULL || strncmp(file, "/var
/lib
/dpkg
/", strlen("/var
/lib
/dpkg
/")) != 0)
406 return func_execvp(file, argv);
407 printf("REWRITE execvp call
%s into
%s
\n", file, chrootdir);
408 char newfile[strlen(chrootdir) + strlen(file)];
409 strcpy(newfile, chrootdir);
410 strcat(newfile, file);
411 char const * const baseadmindir = "/var
/lib
/dpkg
";
412 char admindir[strlen(chrootdir) + strlen(baseadmindir)];
413 strcpy(admindir, chrootdir);
414 strcat(admindir, baseadmindir);
415 setenv("DPKG_ADMINDIR
", admindir, 1);
416 return func_execvp(newfile, argv);
419 testsuccess --nomsg gcc -fPIC -shared -o noopchroot.so noopchroot.c -ldl
422 configallowinsecurerepositories() {
423 echo "Acquire
::AllowInsecureRepositories
\"$1\";" > rootdir/etc/apt/apt.conf.d/allow-insecure-repositories.conf
427 configcompression() {
428 while [ -n "$1" ]; do
430 '.') printf ".
\t.
\tcat
\n";;
431 'gz') printf "gzip\tgz
\tgzip
\n";;
432 'bz2') printf "bzip2\tbz
2\tbzip
2\n";;
433 'lzma') printf "lzma
\tlzma
\txz
--format=lzma
\n";;
434 'xz') printf "xz
\txz
\txz
\n";;
435 *) printf "$1\t$1\t$1\n";;
438 done > ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf
445 gzip) COMPRESS='gz';;
446 bzip2) COMPRESS='bz2';;
447 lzma) COMPRESS='lzma';;
449 *) msgdie "Compressor
$COMPRESSOR is unknown to framework
, so can
't be forced by forcecompressor!";;
451 local CONFFILE="${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/00force-compressor"
452 echo "Acquire::CompressionTypes::Order { \"${COMPRESS}\"; };
453 Dir::Bin::uncompressed \"/does/not/exist\";
454 Dir::Bin::gzip \"/does/not/exist\";
455 Dir::Bin::bzip2 \"/does/not/exist\";
456 Dir::Bin::lzma \"/does/not/exist\";
457 Dir::Bin::xz \"/does/not/exist\";" > "$CONFFILE"
458 if [ -e "/bin/${COMPRESSOR}" ]; then
459 echo "Dir::Bin::${COMPRESSOR} \"/bin/${COMPRESSOR}\";" >> "$CONFFILE"
460 elif [ -e "/usr/bin/${COMPRESSOR}" ]; then
461 echo "Dir::Bin::${COMPRESSOR} \"/usr/bin/${COMPRESSOR}\";" >> "$CONFFILE"
462 elif [ "${COMPRESSOR}" = 'lzma
' ]; then
463 echo 'Dir
::Bin
::xz
"/usr/bin/xz";' >> "$CONFFILE"
464 COMPRESSOR_CMD='xz
--format=lzma
'
466 msgtest 'Test
for availability of compressor
' "${COMPRESSOR}"
471 setupsimplenativepackage() {
475 local RELEASE="${4:-unstable}"
476 local DEPENDENCIES="$5"
477 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
478 If you find such a package installed on your system,
479 something went horribly wrong! They are autogenerated
480 und used only by testcases and surf no other propose…"}"
482 local SECTION="${7:-others}"
484 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
487 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
489 local BUILDDIR=incoming/${NAME}-${VERSION}
490 mkdir -p ${BUILDDIR}/debian/source
492 echo "* most suckless software product ever" > FEATURES
493 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
494 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
498 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
499 test -e debian/control || echo "Source: $NAME
502 Maintainer: Joe Sixpack <joe@example.org>
503 Build-Depends: debhelper (>= 7)
504 Standards-Version: 3.9.1
506 Package: $NAME" > debian/control
507 if [ "$ARCH" = 'all
' ]; then
508 echo "Architecture: all" >> debian/control
510 echo "Architecture: any" >> debian/control
512 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
513 echo "Description: $DESCRIPTION" >> debian/control
515 test -e debian/compat || echo "7" > debian/compat
516 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
517 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
521 buildsimplenativepackage() {
524 if [ "$(echo "$NAME" | cut -c 1-3)" = 'lib
' ]; then
525 NM="$(echo "$NAME" | cut -c 1-4)"
527 NM="$(echo "$NAME" | cut -c 1)"
531 local RELEASE="${4:-unstable}"
532 local DEPENDENCIES="$5"
533 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
534 If you find such a package installed on your system,
535 something went horribly wrong! They are autogenerated
536 und used only by testcases and surf no other propose…"}"
538 local SECTION="${7:-others}"
539 local PRIORITY="${8:-optional}"
541 local COMPRESS_TYPE="${10:-gzip}"
543 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
546 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
548 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
550 msgtest "Build source package in version ${VERSION} for ${RELEASE} in ${DISTSECTION}" "$NAME"
551 mkdir -p $BUILDDIR/debian/source
552 echo "* most suckless software product ever" > ${BUILDDIR}/FEATURES
554 echo '$NAME says
\"Hello
!\"'" > ${BUILDDIR}/${NAME}
556 echo "Copyleft by Joe Sixpack $(date +%Y)" > ${BUILDDIR}/debian/copyright
557 echo "$NAME ($VERSION) $RELEASE; urgency=low
561 -- Joe Sixpack <joe@example.org> $(date -R)" > ${BUILDDIR}/debian/changelog
565 Maintainer: Joe Sixpack <joe@example.org>
566 Standards-Version: 3.9.3" > ${BUILDDIR}/debian/control
567 local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')"
568 test -z "$BUILDDEPS" || echo "$BUILDDEPS" >> ${BUILDDIR}/debian/control
570 Package: $NAME" >> ${BUILDDIR}/debian/control
572 if [ "$ARCH" = 'all
' ]; then
573 echo "Architecture: all" >> ${BUILDDIR}/debian/control
575 echo "Architecture: any" >> ${BUILDDIR}/debian/control
577 local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')"
578 test -z "$DEPS" || echo "$DEPS" >> ${BUILDDIR}/debian/control
579 echo "Description: $DESCRIPTION" >> ${BUILDDIR}/debian/control
581 echo '3.0 (native
)' > ${BUILDDIR}/debian/source/format
583 testsuccess --nomsg dpkg-source -b ${NAME}-${VERSION}
585 sed -n 's
#^dpkg-source: info: building [^ ]\+ in ##p' ${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output \
587 echo "pool/${SRC}" >> ${BUILDDIR}/..
/${RELEASE}.
${DISTSECTION}.srclist
588 # if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then
589 # aptkey --keyring ./keys/joesixpack.pub --secret-keyring ./keys/joesixpack.sec --quiet --readonly \
590 # adv --yes --default-key 'Joe Sixpack' \
591 # --clearsign -o "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
592 # mv "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
596 for arch
in $(getarchitecturesfromcommalist "$ARCH"); do
597 msgtest
"Build binary package for ${RELEASE} in ${SECTION}" "$NAME"
598 rm -rf ${BUILDDIR}/debian
/tmp
599 mkdir -p ${BUILDDIR}/debian
/tmp
/DEBIAN
${BUILDDIR}/debian
/tmp
/usr
/share
/doc
/${NAME} ${BUILDDIR}/debian
/tmp
/usr
/bin
600 cp ${BUILDDIR}/debian
/copyright
${BUILDDIR}/debian
/changelog
${BUILDDIR}/FEATURES
${BUILDDIR}/debian
/tmp
/usr
/share
/doc
/${NAME}
601 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian
/tmp
/usr
/bin
/${NAME}-${arch}
602 if [ -n "$FILE_TREE" ]; then
603 cp -ar "$FILE_TREE" ${BUILDDIR}/debian
/tmp
606 (cd ${BUILDDIR}; dpkg
-gencontrol -DArchitecture=$arch)
607 (cd ${BUILDDIR}/debian
/tmp
; md5sum $(find usr/ -type f) > DEBIAN
/md5sums
)
608 local LOG
="${BUILDDIR}/../${NAME}_${VERSION}_${arch}.dpkg-deb.log"
609 # ensure the right permissions as dpkg-deb insists
610 chmod 755 ${BUILDDIR}/debian
/tmp
/DEBIAN
611 testsuccess
--nomsg dpkg
-deb -Z${COMPRESS_TYPE} --build ${BUILDDIR}/debian
/tmp
${BUILDDIR}/..
612 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/..
/${RELEASE}.
${DISTSECTION}.pkglist
615 local CHANGEPATH
="${BUILDDIR}/../${DISTSECTION}/${NM}/${NAME}/${NAME}_${VERSION}"
617 cp ${BUILDDIR}/debian
/changelog
$CHANGEPATH
626 local ARCH
=$(getarchitecture $4)
627 local PKGNAME
="$(echo "$BUILDDIR" | grep -o '[^/]*$')"
628 local BUILDLOG
="$(readlink -f "${BUILDDIR}/../${PKGNAME}_${RELEASE}_${SECTION}.dpkg-bp.log")"
629 msgtest
"Build package for ${RELEASE} in ${SECTION}" "$PKGNAME"
631 if [ "$ARCH" = "all" ]; then
632 ARCH
="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
634 testsuccess
--nomsg dpkg
-buildpackage -uc -us -a$ARCH
635 cp ${TMPWORKINGDIRECTORY}/rootdir
/tmp
/testsuccess.output
$BUILDLOG
636 local PKGS
="$(grep '^dpkg-deb: building package' $BUILDLOG | cut -d'/' -f 2 | sed -e "s#'\.##")"
637 local SRCS
="$(grep '^dpkg-source: info: building' $BUILDLOG | grep -o '[a-z0-9._+~-]*$')"
640 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming
/${RELEASE}.
${SECTION}.pkglist
643 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming
/${RELEASE}.
${SECTION}.srclist
648 if [ -d incoming
]; then
649 buildaptarchivefromincoming
"$@"
651 buildaptarchivefromfiles
"$@"
655 createaptftparchiveconfig
() {
656 local COMPRESSORS
="$(cut -d' ' -f 1 ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | tr '\n' ' ')"
657 local COMPRESSORS
="${COMPRESSORS%* }"
658 local ARCHS
="$(getarchitectures)"
660 ArchiveDir "' >> ftparchive.conf
661 echo -n $(readlink -f .) >> ftparchive.conf
663 CacheDir "' >> ftparchive.conf
664 echo -n $(readlink -f ..) >> ftparchive.conf
666 FileListDir "' >> ftparchive.conf
667 echo -n $(readlink -f pool/) >> ftparchive.conf
671 Packages::Compress "'"$COMPRESSORS"'";
672 Sources::Compress "'"$COMPRESSORS"'";
673 Contents::Compress "'"$COMPRESSORS"'";
674 Translation::Compress "'"$COMPRESSORS"'";
675 LongDescription "false";
679 SrcDirectory "pool/";
685 Label "apttestcases";
687 Description "repository with dummy packages";
688 Architectures "' >> ftparchive.conf
689 echo -n "$ARCHS" >> ftparchive.conf
693 };' >> ftparchive.conf
694 for DIST
in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
695 echo -n 'tree "dists/' >> ftparchive.conf
696 echo -n "$DIST" >> ftparchive.conf
698 Architectures "' >> ftparchive.conf
699 echo -n "$ARCHS" >> ftparchive.conf
701 FileList "' >> ftparchive.conf
702 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
704 SourceFileList "' >> ftparchive.conf
705 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
707 Sections "' >> ftparchive.conf
708 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
710 };' >> ftparchive.conf
714 buildaptftparchivedirectorystructure
() {
715 local DISTS
="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
716 for DIST
in $DISTS; do
717 local SECTIONS
="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
718 for SECTION
in $SECTIONS; do
719 local ARCHS
="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
720 for ARCH
in $ARCHS; do
721 mkdir -p dists
/${DIST}/${SECTION}/binary
-${ARCH}
723 mkdir -p dists
/${DIST}/${SECTION}/source
724 mkdir -p dists
/${DIST}/${SECTION}/i18n
734 local DEPENDENCIES
="$5"
735 local PRIORITY
="${6:-optional}"
736 local DESCRIPTION
="${7:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASES}
737 If you find such a package installed on your system,
738 something went horribly wrong! They are autogenerated
739 und used only by testcases and surf no other propose…"}"
741 for RELEASE in $(printf '%s' "$RELEASES" | tr ',' '\n'); do
742 if [ "$RELEASE" = 'installed' ]; then
743 insertinstalledpackage "$2" "$3" "$4" "$5" "$6" "$7"
746 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
747 if [ "$arch" = 'all' -o "$arch" = 'none' ]; then
748 ARCHS="$(getarchitectures)"
752 for BUILDARCH in $ARCHS; do
753 local PPATH="aptarchive
/dists
/${RELEASE}/main
/binary
-${BUILDARCH}"
755 local FILE="${PPATH}/Packages
"
760 Maintainer
: Joe Sixpack
<joe@example.org
>" >> $FILE
761 test "$arch" = 'none' || echo "Architecture
: $arch" >> $FILE
762 echo "Version
: $VERSION
763 Filename
: pool
/main
/${NAME}/${NAME}_
${VERSION}_
${arch}.deb
" >> $FILE
764 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
765 echo "Description
: $(printf '%s' "$DESCRIPTION" | head -n 1)" >> $FILE
766 echo "Description
-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)" >> $FILE
770 mkdir -p aptarchive/dists/${RELEASE}/main/source aptarchive/dists/${RELEASE}/main/i18n
771 touch aptarchive/dists/${RELEASE}/main/source/Sources
773 Description
-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)
774 Description
-en: $DESCRIPTION
775 " >> aptarchive/dists/${RELEASE}/main/i18n/Translation-en
784 local DEPENDENCIES="$5"
786 local SPATH="aptarchive
/dists
/${RELEASE}/main
/source"
788 local FILE="${SPATH}/Sources
"
792 Maintainer
: Joe Sixpack
<joe@example.org
>
793 Architecture
: $ARCH" >> $FILE
794 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
796 d41d8cd98f00b204e9800998ecf8427e
0 ${NAME}_
${VERSION}.dsc
797 d41d8cd98f00b204e9800998ecf8427e
0 ${NAME}_
${VERSION}.
tar.gz
801 insertinstalledpackage() {
805 local DEPENDENCIES="$4"
806 local PRIORITY="${5:-optional}"
807 local STATUS="${6:-install ok installed}"
808 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/installed
809 If you
find such a package installed on your system
,
810 something went horribly wrong
! They are autogenerated
811 und used only by testcases and surf no other propose…
"}"
813 local FILE
='rootdir/var/lib/dpkg/status'
814 local INFO
='rootdir/var/lib/dpkg/info'
815 for arch
in $(getarchitecturesfromcommalist "$ARCH"); do
821 Maintainer: Joe Sixpack <joe@example.org>
822 Version: $VERSION" >> $FILE
823 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
824 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
825 echo "Description: $DESCRIPTION" >> $FILE
827 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
828 echo -n > ${INFO}/${NAME}:${arch}.list
830 echo -n > ${INFO}/${NAME}.list
836 buildaptarchivefromincoming
() {
837 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
839 [ -e pool
] || ln -s ..
/incoming pool
840 [ -e ftparchive.conf
] || createaptftparchiveconfig
841 [ -e dists
] || buildaptftparchivedirectorystructure
842 msgninfo
"\tGenerate Packages, Sources and Contents files… "
843 testsuccess aptftparchive generate ftparchive.conf
846 generatereleasefiles
"$@"
849 buildaptarchivefromfiles
() {
850 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
851 local DIR
='aptarchive'
852 if [ -d "${DIR}/dists" ]; then DIR
="${DIR}/dists"; fi
853 find "$DIR" -name 'Packages' -o -name 'Sources' -o -name 'Translation-*' | while read line
; do
854 msgninfo
"\t${line} file… "
855 compressfile
"$line" "$1"
858 generatereleasefiles
"$@"
862 cat ${TMPWORKINGDIRECTORY}/rootdir
/etc
/testcase
-compressor.conf
| while read compressor extension
command; do
863 if [ "$compressor" = '.' ]; then
869 cat "$1" | $command > "${1}.${extension}"
871 touch -d "$2" "${1}.${extension}"
876 # can be overridden by testcases for their pleasure
877 getcodenamefromsuite
() {
879 unstable
) echo 'sid';;
883 getreleaseversionfromsuite
() { true
; }
884 getlabelfromsuite
() { true
; }
885 getoriginfromsuite
() { true
; }
887 generatereleasefiles
() {
888 # $1 is the Date header and $2 is the ValidUntil header to be set
889 # both should be given in notation date/touch can understand
890 msgninfo
"\tGenerate Release files… "
891 if [ -e aptarchive
/dists
]; then
892 for dir
in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
893 local SUITE
="$(echo "$dir" | cut -d'/' -f 4)"
894 local CODENAME
="$(getcodenamefromsuite $SUITE)"
895 local VERSION
="$(getreleaseversionfromsuite $SUITE)"
896 local LABEL
="$(getlabelfromsuite $SUITE)"
897 local ORIGIN
="$(getoriginfromsuite $SUITE)"
898 if [ -n "$VERSION" ]; then
899 VERSION
="-o APT::FTPArchive::Release::Version=${VERSION}"
901 if [ -n "$LABEL" ]; then
902 LABEL
="-o APT::FTPArchive::Release::Label=${LABEL}"
904 if [ -n "$ORIGIN" ]; then
905 ORIGIN
="-o APT::FTPArchive::Release::Origin=${ORIGIN}"
907 aptftparchive
-qq release
$dir \
908 -o APT
::FTPArchive
::Release
::Suite
="${SUITE}" \
909 -o APT
::FTPArchive
::Release
::Codename
="${CODENAME}" \
913 | sed -e '/0 Release$/ d' > $dir/Release
# remove the self reference
914 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
916 NotAutomatic: yes' $dir/Release
918 if [ -n "$1" -a "$1" != "now" ]; then
919 sed -i "s/^Date: .*$/Date: $(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')/" $dir/Release
923 Valid-Until: $(date -d "$2" '+%a, %d %b %Y %H:%M:%S %Z')" $dir/Release
927 aptftparchive
-qq release .
/aptarchive
| sed -e '/0 Release$/ d' > aptarchive
/Release
# remove the self reference
929 if [ -n "$1" -a "$1" != "now" ]; then
930 for release
in $(find ./aptarchive -name 'Release'); do
931 touch -d "$1" $release
937 setupdistsaptarchive
() {
938 local APTARCHIVE
=$(readlink -f ./aptarchive)
939 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb.list
940 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb-src.list
941 for DISTS
in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
942 SECTIONS
=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
943 msgninfo
"\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
944 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb.list
945 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb-src.list
950 setupflataptarchive
() {
951 local APTARCHIVE
=$(readlink -f ./aptarchive)
952 if [ -f ${APTARCHIVE}/Packages
]; then
953 msgninfo
"\tadd deb sources.list line… "
954 echo "deb file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
957 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
959 if [ -f ${APTARCHIVE}/Sources
]; then
960 msgninfo
"\tadd deb-src sources.list line… "
961 echo "deb-src file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
964 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
970 if [ "$1" = '--no-update' ]; then
975 if [ -e aptarchive
/dists
]; then
980 signreleasefiles
'Joe Sixpack'
981 if [ "1" != "$NOUPDATE" ]; then
982 testsuccess aptget update
-o Debug
::pkgAcquire
::Worker
=true
-o Debug
::Acquire
::gpgv
=true
987 local SIGNER
="${1:-Joe Sixpack}"
988 local REPODIR
="${2:-aptarchive}"
989 local KEY
="keys/$(echo "$SIGNER" | tr 'A-Z' 'a-z' | sed 's# ##g')"
990 local GPG
="aptkey --quiet --keyring ${KEY}.pub --secret-keyring ${KEY}.sec --readonly adv --batch --yes"
991 msgninfo
"\tSign archive with $SIGNER key $KEY… "
992 local REXKEY
='keys/rexexpired'
993 local SECEXPIREBAK
="${REXKEY}.sec.bak"
994 local PUBEXPIREBAK
="${REXKEY}.pub.bak"
995 if [ "${SIGNER}" = 'Rex Expired' ]; then
996 # the key is expired, so gpg doesn't allow to sign with and the --faked-system-time
997 # option doesn't exist anymore (and using faketime would add a new obscure dependency)
998 # therefore we 'temporary' make the key not expired and restore a backup after signing
999 cp ${REXKEY}.sec
$SECEXPIREBAK
1000 cp ${REXKEY}.pub
$PUBEXPIREBAK
1001 local SECUNEXPIRED
="${REXKEY}.sec.unexpired"
1002 local PUBUNEXPIRED
="${REXKEY}.pub.unexpired"
1003 if [ -f "$SECUNEXPIRED" ] && [ -f "$PUBUNEXPIRED" ]; then
1004 cp $SECUNEXPIRED ${REXKEY}.sec
1005 cp $PUBUNEXPIRED ${REXKEY}.pub
1007 if ! printf "expire\n1w\nsave\n" | $GPG --default-key "$SIGNER" --command-fd 0 --edit-key "${SIGNER}" >setexpire.gpg
2>&1; then
1011 cp ${REXKEY}.sec
$SECUNEXPIRED
1012 cp ${REXKEY}.pub
$PUBUNEXPIRED
1015 for RELEASE
in $(find ${REPODIR}/ -name Release); do
1016 $GPG --default-key "$SIGNER" --armor --detach-sign --sign --output ${RELEASE}.gpg
${RELEASE}
1017 local INRELEASE
="$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')"
1018 $GPG --default-key "$SIGNER" --clearsign --output $INRELEASE $RELEASE
1019 # we might have set a specific date for the Release file, so copy it
1020 touch -d "$(stat --format "%y" ${RELEASE})" ${RELEASE}.gpg
${INRELEASE}
1022 if [ -f "$SECEXPIREBAK" ] && [ -f "$PUBEXPIREBAK" ]; then
1023 mv -f $SECEXPIREBAK ${REXKEY}.sec
1024 mv -f $PUBEXPIREBAK ${REXKEY}.pub
1029 redatereleasefiles
() {
1030 local DATE
="$(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')"
1031 for release
in $(find aptarchive/ -name 'Release'); do
1032 sed -i "s/^Date: .*$/Date: ${DATE}/" $release
1033 touch -d "$DATE" $release
1035 signreleasefiles
"${2:-Joe Sixpack}"
1039 local WEBSERVER
="${3:-http://localhost:8080}"
1041 if [ "$1" = '--no-check' ]; then
1045 local DOWNLOG
='rootdir/tmp/download-testfile.log'
1046 local STATUS
='downloaded/webserverconfig.status'
1047 rm -f "$STATUS" "$DOWNLOG"
1049 if [ -n "$2" ]; then
1050 msgtest
"Set webserver config option '${1}' to" "$2"
1051 URI
="${WEBSERVER}/_config/set/${1}/${2}"
1053 msgtest
'Clear webserver config option' "${1}"
1054 URI
="${WEBSERVER}/_config/clear/${1}"
1056 if downloadfile
"$URI" "$STATUS" > "$DOWNLOG"; then
1059 cat "$DOWNLOG" "$STATUS" || true
1062 $NOCHECK || testwebserverlaststatuscode
'200'
1065 rewritesourceslist
() {
1066 local APTARCHIVE
="file://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive")"
1067 for LIST
in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
1068 sed -i $LIST -e "s#$APTARCHIVE#${1}#" -e "s#http://localhost:8080/#${1}#" -e "s#https://localhost:4433/#${1}#"
1072 # wait for up to 10s for a pid file to appear to avoid possible race
1073 # when a helper is started and dosn't write the PID quick enough
1076 for i
in $(seq 10); do
1077 if test -s "$PIDFILE"; then
1082 msgdie
"waiting for $PIDFILE failed"
1086 changetowebserver
() {
1087 if [ "$1" != '--no-rewrite' ]; then
1088 rewritesourceslist
'http://localhost:8080/'
1092 if test -x ${APTWEBSERVERBINDIR}/aptwebserver
; then
1094 local LOG
="webserver.log"
1095 if ! aptwebserver
-o aptwebserver
::fork
=1 "$@" >$LOG 2>&1 ; then
1099 waitforpidfile aptwebserver.pid
1100 local PID
="$(cat aptwebserver.pid)"
1101 if [ -z "$PID" ]; then
1102 msgdie
'Could not fork aptwebserver successfully'
1104 addtrap
"kill $PID;"
1107 msgdie
'You have to build aptwerbserver or install a webserver'
1111 changetohttpswebserver
() {
1112 if ! which stunnel4
>/dev
/null
; then
1113 msgdie
'You need to install stunnel4 for https testcases'
1115 if [ ! -e "${TMPWORKINGDIRECTORY}/aptarchive/aptwebserver.pid" ]; then
1116 changetowebserver
--no-rewrite "$@"
1118 echo "pid = ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid
1119 cert = ${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem
1125 " > ${TMPWORKINGDIRECTORY}/stunnel.conf
1126 stunnel4
"${TMPWORKINGDIRECTORY}/stunnel.conf"
1127 waitforpidfile
"${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid"
1128 local PID
="$(cat ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid)"
1129 if [ -z "$PID" ]; then
1130 msgdie
'Could not fork stunnel4 successfully'
1132 addtrap
'prefix' "kill ${PID};"
1133 rewritesourceslist
'https://localhost:4433/'
1137 mkdir -p rootdir
/media
/cdrom
/.disk
1138 local CD
="$(readlink -f rootdir/media/cdrom)"
1139 echo "acquire::cdrom::mount \"${CD}\";
1140 acquire::cdrom::${CD}/::mount \"mv ${CD}-unmounted ${CD}\";
1141 acquire::cdrom::${CD}/::umount \"mv ${CD} ${CD}-unmounted\";
1142 acquire::cdrom::autodetect 0;" > rootdir
/etc
/apt
/apt.conf.d
/00cdrom
1143 echo -n "$1" > ${CD}/.disk
/info
1144 if [ ! -d aptarchive
/dists
]; then
1145 msgdie
'Flat file archive cdroms can not be created currently'
1148 mv aptarchive
/dists
"$CD"
1149 ln -s "$(readlink -f ./incoming)" $CD/pool
1150 find rootdir
/etc
/apt
/sources.list.d
/ -name 'apt-test-*.list' -delete
1151 # start with an unmounted disk
1152 mv "${CD}" "${CD}-unmounted"
1153 # we don't want the disk to be modifiable
1154 addtrap
'prefix' "chmod -f -R +w $PWD/rootdir/media/cdrom/dists/ $PWD/rootdir/media/cdrom-unmounted/dists/ || true;"
1155 chmod -R 555 rootdir
/media
/cdrom
-unmounted/dists
1159 local PROTO
="${1%%:*}"
1160 if ! apthelper
-o Debug
::Acquire
::${PROTO}=1 -o Debug
::pkgAcquire
::Worker
=1 \
1161 download
-file "$1" "$2" "$3" 2>&1 ; then
1164 # only if the file exists the download was successful
1165 if [ -r "$2" ]; then
1173 local DIFFTEXT
="$(command diff -u "$@" 2>&1 | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
1174 if [ -n "$DIFFTEXT" ]; then
1176 echo >&2 "$DIFFTEXT"
1186 msgtest
"Test for correctness of file" "$FILE"
1187 if [ -z "$*" ]; then
1188 echo -n "" | checkdiff
- $FILE && msgpass
|| msgfail
1190 echo "$*" | checkdiff
- $FILE && msgpass
|| msgfail
1195 msgtest
"Test for no output of" "$*"
1196 local COMPAREFILE
="${TMPWORKINGDIRECTORY}/rootdir/tmp/testempty.comparefile"
1197 if "$@" >$COMPAREFILE 2>&1 && test ! -s $COMPAREFILE; then
1204 aptautotest
'testempty' "$@"
1208 local MSG
='Test of equality of'
1209 if [ "$1" = '--nomsg' ]; then
1214 local COMPAREFILE
="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.comparefile"
1215 echo "$1" > $COMPAREFILE
1218 if [ -n "$MSG" ]; then
1221 "$@" 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
1222 aptautotest
'testequal' "$@"
1226 local COMPAREFILE1
="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile1"
1227 local COMPAREFILE2
="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile2"
1228 local COMPAREAGAINST
="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.compareagainst"
1229 echo "$1" > $COMPAREFILE1
1230 echo "$2" > $COMPAREFILE2
1232 msgtest
"Test for equality OR of" "$*"
1233 "$@" >$COMPAREAGAINST 2>&1 || true
1234 if checkdiff
$COMPAREFILE1 $COMPAREAGAINST >/dev
/null
2>&1 || \
1235 checkdiff
$COMPAREFILE2 $COMPAREAGAINST >/dev
/null
2>&1
1239 echo -n "\n${CINFO}Diff against OR 1${CNORMAL}"
1240 checkdiff
$COMPAREFILE1 $COMPAREAGAINST || true
1241 echo -n "${CINFO}Diff against OR 2${CNORMAL}"
1242 checkdiff
$COMPAREFILE2 $COMPAREAGAINST || true
1245 aptautotest
'testequalor2' "$@"
1249 local VIRTUAL
="N: Can't select versions from package '$1' as it is purely virtual"
1252 while [ -n "$1" ]; do
1254 N: Can't select versions from package '$1' as it is purely virtual"
1255 PACKAGE
="${PACKAGE} $1"
1258 msgtest
"Test for virtual packages" "apt-cache show $PACKAGE"
1260 N: No packages found"
1261 local COMPAREFILE
="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.comparefile"
1262 local ARCH
="$(getarchitecture 'native')"
1263 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
1264 aptcache show
-q=0 $PACKAGE 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
1268 msgtest
"Test for non-existent packages" "apt-cache show $*"
1269 local SHOWPKG
="$(aptcache show "$@" 2>&1 | grep '^Package: ')"
1270 if [ -n "$SHOWPKG" ]; then
1283 msgtest
"Test that $NR package(s) are in state $STATE with" "dpkg -l $*"
1284 local PKGS
="$(dpkg -l "$@" 2>/dev/null | grep "^${STATE}" | wc -l)"
1285 if [ "$PKGS" != $NR ]; then
1287 dpkg
-l "$@" | grep '^[a-z]' >&2
1294 testdpkginstalled
() {
1295 testdpkgstatus
'ii' "$#" "$@"
1298 testdpkgnotinstalled
() {
1299 testdpkgstatus
'ii' '0' "$@"
1303 local COMPAREFILE
="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedauto.comparefile"
1304 if [ -n "$1" ]; then
1305 msgtest
'Test for correctly marked as auto-installed' "$*"
1306 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
1308 msgtest
'Test for correctly marked as auto-installed' 'no package'
1309 echo -n > $COMPAREFILE
1311 aptmark showauto
2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
1319 if [ "$1" = 'grep' ]; then
1320 while [ -n "$2" ]; do shift; done
1321 echo "#### Complete file: $1 ####"
1322 cat >&2 "$1" || true
1323 echo '#### grep output ####'
1324 elif [ "$1" = 'test' ]; then
1325 # doesn't support ! or non-file flags
1326 msgfailoutputstatfile
() {
1327 local FILEFLAGS
='^-[bcdefgGhkLOprsStuwx]$'
1328 if expr match
"$1" "$FILEFLAGS" >/dev
/null
; then
1329 echo "#### stat(2) of file: $2 ####"
1333 msgfailoutputstatfile
"$2" "$3"
1334 while [ -n "$5" ] && [ "$4" = '-o' -o "$4" = '-a' ]; do
1336 msgfailoutputstatfile
"$2" "$3"
1338 echo '#### test output ####'
1345 if [ "$1" = '--nomsg' ]; then
1348 msgtest
'Test for successful execution of' "$*"
1350 local OUTPUT
="${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output"
1351 if "$@" >${OUTPUT} 2>&1; then
1352 if expr match
"$1" '^apt.*' >/dev
/null
; then
1353 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1354 msgfailoutput
'compiler detected undefined behavior' "$OUTPUT" "$@"
1355 elif grep -q -E '^[WE]: ' "$OUTPUT"; then
1356 msgfailoutput
'successful run, but output contains warnings/errors' "$OUTPUT" "$@"
1365 msgfailoutput
"exitcode $EXITCODE" "$OUTPUT" "$@"
1367 aptautotest
'testsuccess' "$@"
1370 if [ "$1" = '--nomsg' ]; then
1373 msgtest
'Test for successful execution with warnings of' "$*"
1375 local OUTPUT
="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarning.output"
1376 if "$@" >${OUTPUT} 2>&1; then
1377 if expr match
"$1" '^apt.*' >/dev
/null
; then
1378 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1379 msgfailoutput
'compiler detected undefined behavior' "$OUTPUT" "$@"
1380 elif grep -q -E '^E: ' "$OUTPUT"; then
1381 msgfailoutput
'successful run, but output contains errors' "$OUTPUT" "$@"
1382 elif ! grep -q -E '^W: ' "$OUTPUT"; then
1383 msgfailoutput
'successful run, but output contains no warnings' "$OUTPUT" "$@"
1394 msgfail
"exitcode $EXITCODE"
1396 aptautotest
'testwarning' "$@"
1399 if [ "$1" = '--nomsg' ]; then
1402 msgtest
'Test for failure in execution of' "$*"
1404 local OUTPUT
="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output"
1405 if "$@" >${OUTPUT} 2>&1; then
1407 msgfailoutput
"exitcode $EXITCODE" "$OUTPUT" "$@"
1410 if expr match
"$1" '^apt.*' >/dev
/null
; then
1411 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1412 msgfailoutput
'compiler detected undefined behavior' "$OUTPUT" "$@"
1413 elif ! grep -q -E '^E: ' "$OUTPUT"; then
1414 msgfailoutput
"run failed with exitcode ${EXITCODE}, but with no errors" "$OUTPUT" "$@"
1422 aptautotest
'testfailure' "$@"
1425 testsuccessequal
() {
1429 testfileequal
"${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output" "$CMP"
1431 testwarningequal
() {
1435 testfileequal
"${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarning.output" "$CMP"
1437 testfailureequal
() {
1441 testfileequal
"${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output" "$CMP"
1448 msgtest
'Check that the output of the previous failed command has expected' 'failures and warnings'
1449 grep '^\(W\|E\):' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output" > "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailureequal.output" 2>&1 || true
1450 if echo "$CMP" | checkdiff
- "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailureequal.output"; then
1453 echo '### Complete output ###'
1454 cat "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output"
1460 msgtest
"Test that file $1 has $2 $3" "$4"
1461 if [ "$4" "$3" "$(stat --format "$2" "$1")" ]; then
1465 ls -ld >&2 "$1" || true
1466 echo -n >&2 "stat(1) reports for $2: "
1467 stat
--format "$2" "$1" || true
1471 testaccessrights
() {
1472 testfilestats
"$1" '%a' '=' "$2"
1475 testwebserverlaststatuscode
() {
1476 local DOWNLOG
='rootdir/tmp/webserverstatus-testfile.log'
1477 local STATUS
='downloaded/webserverstatus-statusfile.log'
1478 rm -f "$DOWNLOG" "$STATUS"
1479 msgtest
'Test last status code from the webserver was' "$1"
1480 if downloadfile
"http://localhost:8080/_config/find/aptwebserver::last-status-code" "$STATUS" > "$DOWNLOG" && [ "$(cat "$STATUS")" = "$1" ]; then
1484 if [ -n "$2" ]; then
1486 echo >&2 '#### Additionally provided output files contain:'
1489 echo >&2 '#### Download log of the status code:'
1491 msgfail
"Status was $(cat "$STATUS")"
1496 echo "STOPPED execution. Press enter to continue"
1501 listcurrentlistsdirectory
() {
1503 find rootdir
/var
/lib
/apt
/lists
-maxdepth 1 -type d
| while read line
; do
1504 stat
--format '%U:%G:%a:%n' "$line"
1506 find rootdir
/var
/lib
/apt
/lists
-maxdepth 1 \
! -type d
| while read line
; do
1507 stat
--format '%U:%G:%a:%s:%y:%n' "$line"
1512 ### convinience hacks ###
1514 # creating some directories by hand is a tedious task, so make it look simple
1515 if [ "$*" = '-p rootdir/var/lib/apt/lists' ] || [ "$*" = "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" ] ||
1516 [ "$*" = '-p rootdir/var/lib/apt/lists/partial' ] || [ "$*" = "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial" ]; then
1517 # only the last directory created by mkdir is effected by the -m !
1518 command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt"
1519 command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists"
1520 command mkdir -m 700 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial"
1521 touch "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/lock"
1522 if [ "$(id -u)" = '0' ]; then
1523 chown _apt
:root
"${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial"
1530 ### The following tests are run by most test methods automatically to check
1531 ### general things about commands executed without writing the test every time.
1537 local AUTOTEST
="aptautotest_$(basename "$CMD" | tr -d '-')_$(echo "$FIRSTOPT" | tr -d '-')"
1538 if command -v $AUTOTEST >/dev
/null
; then
1540 # save and restore the *.output files from other tests
1541 # as we might otherwise override them in these automatic tests
1542 rm -rf ${TMPWORKINGDIRECTORY}/rootdir
/tmp
-before
1543 mv ${TMPWORKINGDIRECTORY}/rootdir
/tmp
${TMPWORKINGDIRECTORY}/rootdir
/tmp
-before
1544 mkdir ${TMPWORKINGDIRECTORY}/rootdir
/tmp
1545 $AUTOTEST "$TESTCALL" "$@"
1546 rm -rf ${TMPWORKINGDIRECTORY}/rootdir
/tmp
-aptautotest
1547 mv ${TMPWORKINGDIRECTORY}/rootdir
/tmp
${TMPWORKINGDIRECTORY}/rootdir
/tmp
-aptautotest
1548 mv ${TMPWORKINGDIRECTORY}/rootdir
/tmp
-before ${TMPWORKINGDIRECTORY}/rootdir
/tmp
1552 aptautotest_aptget_update
() {
1554 while [ -n "$2" ]; do
1555 if [ "$2" = '--print-uris' ]; then return; fi # simulation mode
1558 if ! test -d "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists"; then return; fi
1559 testfilestats
"${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755"
1560 testfilestats
"${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755"
1561 # all copied files are properly chmodded
1562 for file in $(find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" -type f ! -name 'lock'); do
1563 testfilestats
"$file" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:644"
1565 if [ "$TESTCALL" = 'testsuccess' ]; then
1566 # failure cases can retain partial files and such
1567 testempty
find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial" -mindepth 1 ! \
( -name 'lock' -o -name '*.FAILED' \
)
1570 aptautotest_apt_update
() { aptautotest_aptget_update
"$@"; }
1571 aptautotest_aptcdrom_add
() { aptautotest_aptget_update
"$@"; }
1573 testaptautotestnodpkgwarning
() {
1575 while [ -n "$2" ]; do
1576 if expr match
"$2" '^-[a-z]*s' >/dev
/null
2>&1; then return; fi # simulation mode
1577 if expr match
"$2" '^-dy\?' >/dev
/null
2>&1; then return; fi # download-only mode
1580 testfailure
grep '^dpkg: warning:.*ignor.*' "${TMPWORKINGDIRECTORY}/rootdir/tmp-before/${TESTCALL}.output"
1583 aptautotest_aptget_install
() { testaptautotestnodpkgwarning
"$@"; }
1584 aptautotest_aptget_remove
() { testaptautotestnodpkgwarning
"$@"; }
1585 aptautotest_aptget_purge
() { testaptautotestnodpkgwarning
"$@"; }
1586 aptautotest_apt_install
() { testaptautotestnodpkgwarning
"$@"; }
1587 aptautotest_apt_remove
() { testaptautotestnodpkgwarning
"$@"; }
1588 aptautotest_apt_purge
() { testaptautotestnodpkgwarning
"$@"; }